package com.jiuqi.grid;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.Serializable;

public class GridFontNames implements Serializable, Cloneable {
  private int count;
  
  private String[] names;
  
  public GridFontNames(int maxCount) {
    this.names = new String[maxCount];
    this.count = 0;
  }
  
  public int count() {
    return this.count;
  }
  
  public int addFont(String fontName) {
    for (int i = 0; i < this.count; i++) {
      if (this.names[i].equals(fontName))
        return i; 
    } 
    if (this.count < this.names.length) {
      this.names[this.count] = fontName;
      this.count++;
      return this.count - 1;
    } 
    this.names[0] = fontName;
    return 0;
  }
  
  public String getFont(int index) {
    return (index >= 0 && index < this.count) ? this.names[index] : "";
  }
  
  public void setFont(int index, String value) {
    if (index >= 0 && index < this.count)
      this.names[index] = value; 
  }
  
  public int indexOfFont(String fontName) {
    for (int i = 0; i < this.count; i++) {
      if (this.names[i].equals(fontName))
        return i; 
    } 
    return -1;
  }
  
  public void loadFromStream(Stream stream) throws StreamException {
    this.count = stream.readInt();
    for (int i = 0; i < this.count; i++) {
      byte ll = stream.read();
      int l = (ll < 0) ? (127 + Math.abs(ll)) : ll;
      this.names[i] = stream.readString(l);
    } 
  }
  
  public void saveToStream(Stream stream) throws StreamException {
    stream.writeInt(this.count);
    for (int i = 0; i < this.count; i++) {
      byte[] name = this.names[i].getBytes();
      stream.write((byte)name.length);
      stream.writeBuffer(name, 0, name.length);
    } 
  }
  
  public Object clone() {
    try {
      com.jiuqi.grid.GridFontNames result = (com.jiuqi.grid.GridFontNames)super.clone();
      result.names = new String[this.names.length];
      for (int i = 0; i < this.names.length; i++)
        result.names[i] = this.names[i]; 
      return result;
    } catch (CloneNotSupportedException cloneNotSupportedException) {
      return null;
    } 
  }
}
